
 //fuente linea controlada por dac mcp4725
#include "built_in.h"
#define dir_ADC 0b11000000   //direccion del ADC  con A0 conectado a tierra
//comandos del adc
#define adc_fast 0b000  //Fastmod0
#define adc_write 0b010 //write adc
#define adc_write_ep 0b011 //write adc y eeeprom
#define Tone 150
char  keypadPort at PORTB;
//////////////LCD_declarations//////////////////////////////////////////////////
sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;

// Global varibles
long Voltio=0, Vint=0, retardo=0;
short int  contador=0, aux=0, reg=0, wait=0;
float value;
char *text, kp=0;
unsigned int adc_rd;

void Set_up() {

  ANSEL = 0x04;      // Pin RA2 sets as analog input.
  TRISA = 0x04;
  ADCON1 = 0x82;    // the Vref is Vcc.
  ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
  C1ON_bit = 0;    // analog comparators off.
  C2ON_bit = 0;
  CCP1CON = 0;   //PWM1 y PWM2 off.
  CCP2CON = 0;
  CCP1CON = 0;   //PWM1 y PWM2 off.
  CCP2CON = 0;
  trisc.b3=1;
  trisc.b4=1;
  TRISD0_bit=0;
  TRISD1_bit=0;
  TRISE0_bit=0;
  TRISE1_bit=0;
  Keypad_Init();
  I2C1_Init(100000);
  Delay_ms(200);
  Lcd_Init();
  Lcd_Cmd(_LCD_CLEAR);
  Lcd_Cmd(_LCD_CURSOR_OFF);
  RD0_bit=0;
  RD1_bit=0;
  RE0_bit=0;
  RE1_bit=0;
  text = "VREQ:";
  Lcd_Out(1,1,text);
  text = "VMED:";
  Lcd_Out(2,1,text);
  Delay_ms(10);
}
void buzzer() {
 RD1_bit=1;
 delay_ms(Tone);
 RD1_bit=0;
 delay_ms(Tone);
}

void mcp4725_write(unsigned int dato)
{
}
unsigned int mcp4725_read()
{
}
void print1(){
    unsigned char ch ;
     RE0_bit=1;
     RE1_bit=0;
// Write result in ASCII format
    ch = voltio/1000;
    Lcd_Chr(1,6,48+ch);
    ch = (voltio/ 100 )% 10;
    Lcd_Chr_CP(48+ch);
    Lcd_Chr(1,8,'.');
    ch = (voltio / 10 )% 10;
    Lcd_Chr(1,9,48+ch);
    ch = voltio % 10;
    Lcd_Chr_CP(48+ch);

}
// print2 values for digital mode
void print2(){
    unsigned char ch ;
     RE0_bit=0;
     RE1_bit=1;
// Write result in ASCII format
    ch = voltio/1000;
    Lcd_Chr(1,6,48+ch);
    ch = (voltio/ 100 )% 10;
    Lcd_Chr_CP(48+ch);
    ch = (voltio / 10 )% 10;
    Lcd_Chr_CP(48+ch);
    ch = voltio % 10;
    Lcd_Chr_CP(48+ch);
    Lcd_Chr(1,10,' ');
}
void mcp4725_ADC(float valor)
{
unsigned int dato;
 dato=valor;
 i2c1_Start();
 i2c1_Wr(dir_ADC);
 i2c1_Wr(hi(dato));
 i2c1_Wr(lo(dato));
 I2C1_Stop();
}
void key_pad() {
short int i=0, select=0, clear=0;
contador=0;
Voltio=0;
value=0;
buzzer();
for(i=0; i<=3; i++){
kp=0;
if(aux==1) {
if(reg==0) {
if(clear==1)Voltio=0;
if(clear==2)Voltio=Voltio/10;
if(clear==0)Voltio=(10*Voltio) + contador;
if(Voltio>4095) Voltio=contador;
print2();
}
else {
Voltio=Voltio;
if(Voltio>4095) Voltio=contador;
print2();
reg=0;
}
}
if(aux==0) {
if(reg==0) {
if(clear==1)Voltio=0;
if(clear==2)Voltio=Voltio/10;
if(clear==0)Voltio=(10*Voltio) + contador;
if(Voltio>2000) Voltio=contador;
print1();
}
else {
Voltio=Voltio;
if(Voltio>2000) Voltio=contador;
print1();
reg=0;
}
}
value=Voltio/0.4884;
do  //hope that the keypad is pressed and after thar is free.
kp=Keypad_Key_Click();  //read the keypad.
while (!kp);
switch (kp){
 case  1:  contador = 7; clear=0; break;
 case  2:  contador = 8; clear=0; break;
 case  3:  contador = 9; clear=0; break;
 case  4:  clear=2; break;
 case  5:  contador = 4; clear=0; break;
 case  6:  contador = 5; clear=0; break;
 case  7:  contador = 6; clear=0; break;
 case  8:  clear=1; break;
 case  9:  contador = 1; clear=0; break;
 case  10: contador = 2; clear=0; break;
 case  11: contador = 3; clear=0; break;
 case  12: contador = 0; aux=1; reg++; clear=0; break;
 case  13: select=1; break;
 case  14: contador = 0; clear=0; break;
 case  15: contador=0; aux=0; reg++; clear=0; break;
 case  16: contador = 0; clear=0; break;
 }
 if((select==0)&&(i==3)) i=0;
 if(select==1) i=3;
 buzzer();
 }
   RE1_bit=0;
   RE0_bit=0;
  if(aux==1) Vint = voltio;
  else       Vint = value;

     for(retardo=retardo; retardo<=Vint; retardo++){  //
       RD0_bit=1;
       mcp4725_ADC(retardo);                 // Send value to DAC chip
       Delay_ms(10);                         // Slow down key repeat pace
     }
      for(retardo=retardo; retardo>=Vint; retardo--){
        RD0_bit=1;
        mcp4725_ADC(retardo);                  // Send value to DAC chip
        Delay_ms(10);                         // Slow down key repeat pace
     }
}
void adc_readig() {
 unsigned char ch;
 long tlong;

    tlong = (long)adc_rd * 2500; // Convertir el resultado en milesimas
    tlong = tlong / 1023;        // 0..1023 -> 0-1000
    ch = tlong / 1000;           // Extraer decenas del resultado
    Lcd_Chr(2,6,48+ch);          // Escribir resultado en formato ASCII
    ch = (tlong / 100) % 10;    // Extraer unidades del resultado
    Lcd_Chr_CP(48+ch);           // Escribir resultado en formato ASCII
    Lcd_Chr_CP('.');             // Escribir el punto decimal
    ch = (tlong / 10) % 10;     // Extraer centecimas del resultado
    Lcd_Chr_CP(48+ch);           // Escribir resultado en formato ASCII
    ch = tlong % 10;             // Extraer unicemimas del resultado
    Lcd_Chr_CP(48+ch);           // Escribir resultado en formato ASCII
}
void main()
{
  Set_up();
  mcp4725_ADC(0);
  delay_ms(200);
  buzzer();
  while (1)
  {
   RD0_bit=0;
   adc_rd = ADC_Read(2);
   delay_ms(1);
   for(wait=0; wait<=100; wait++){
   adc_readig();
   if(Keypad_Key_press()) delay_ms(1), key_pad();
  }
 }
}