#line 1 "C:/Users/Usuario/Documents/MikroC_pro_pic/fuentes_lineales_con_control _digital/MCP4725/MCP4725_CNF.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 10 "C:/Users/Usuario/Documents/MikroC_pro_pic/fuentes_lineales_con_control _digital/MCP4725/MCP4725_CNF.c"
char keypadPort at PORTB;

sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;


long Voltio=0, Vint=0, retardo=0;
short int contador=0, aux=0, reg=0, wait=0;
float value;
char *text, kp=0;
unsigned int adc_rd;

void Set_up() {

 ANSEL = 0x04;
 TRISA = 0x04;
 ADCON1 = 0x82;
 ANSELH = 0;
 C1ON_bit = 0;
 C2ON_bit = 0;
 CCP1CON = 0;
 CCP2CON = 0;
 CCP1CON = 0;
 CCP2CON = 0;
 trisc.b3=1;
 trisc.b4=1;
 TRISD0_bit=0;
 TRISD1_bit=0;
 TRISE0_bit=0;
 TRISE1_bit=0;
 Keypad_Init();
 I2C1_Init(100000);
 Delay_ms(200);
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 RD0_bit=0;
 RD1_bit=0;
 RE0_bit=0;
 RE1_bit=0;
 text = "VREQ:";
 Lcd_Out(1,1,text);
 text = "VMED:";
 Lcd_Out(2,1,text);
 Delay_ms(10);
}
void buzzer() {
 RD1_bit=1;
 delay_ms( 150 );
 RD1_bit=0;
 delay_ms( 150 );
}

void mcp4725_write(unsigned int dato)
{
}
unsigned int mcp4725_read()
{
}
void print1(){
 unsigned char ch ;
 RE0_bit=1;
 RE1_bit=0;

 ch = voltio/1000;
 Lcd_Chr(1,6,48+ch);
 ch = (voltio/ 100 )% 10;
 Lcd_Chr_CP(48+ch);
 Lcd_Chr(1,8,'.');
 ch = (voltio / 10 )% 10;
 Lcd_Chr(1,9,48+ch);
 ch = voltio % 10;
 Lcd_Chr_CP(48+ch);

}

void print2(){
 unsigned char ch ;
 RE0_bit=0;
 RE1_bit=1;

 ch = voltio/1000;
 Lcd_Chr(1,6,48+ch);
 ch = (voltio/ 100 )% 10;
 Lcd_Chr_CP(48+ch);
 ch = (voltio / 10 )% 10;
 Lcd_Chr_CP(48+ch);
 ch = voltio % 10;
 Lcd_Chr_CP(48+ch);
 Lcd_Chr(1,10,' ');
}
void mcp4725_ADC(float valor)
{
unsigned int dato;
 dato=valor;
 i2c1_Start();
 i2c1_Wr( 0b11000000 );
 i2c1_Wr( ((char *)&dato)[1] );
 i2c1_Wr( ((char *)&dato)[0] );
 I2C1_Stop();
}
void key_pad() {
short int i=0, select=0, clear=0;
contador=0;
Voltio=0;
value=0;
buzzer();
for(i=0; i<=3; i++){
kp=0;
if(aux==1) {
if(reg==0) {
if(clear==1)Voltio=0;
if(clear==2)Voltio=Voltio/10;
if(clear==0)Voltio=(10*Voltio) + contador;
if(Voltio>4095) Voltio=contador;
print2();
}
else {
Voltio=Voltio;
if(Voltio>4095) Voltio=contador;
print2();
reg=0;
}
}
if(aux==0) {
if(reg==0) {
if(clear==1)Voltio=0;
if(clear==2)Voltio=Voltio/10;
if(clear==0)Voltio=(10*Voltio) + contador;
if(Voltio>2000) Voltio=contador;
print1();
}
else {
Voltio=Voltio;
if(Voltio>2000) Voltio=contador;
print1();
reg=0;
}
}
value=Voltio/0.4884;
do
kp=Keypad_Key_Click();
while (!kp);
switch (kp){
 case 1: contador = 7; clear=0; break;
 case 2: contador = 8; clear=0; break;
 case 3: contador = 9; clear=0; break;
 case 4: clear=2; break;
 case 5: contador = 4; clear=0; break;
 case 6: contador = 5; clear=0; break;
 case 7: contador = 6; clear=0; break;
 case 8: clear=1; break;
 case 9: contador = 1; clear=0; break;
 case 10: contador = 2; clear=0; break;
 case 11: contador = 3; clear=0; break;
 case 12: contador = 0; aux=1; reg++; clear=0; break;
 case 13: select=1; break;
 case 14: contador = 0; clear=0; break;
 case 15: contador=0; aux=0; reg++; clear=0; break;
 case 16: contador = 0; clear=0; break;
 }
 if((select==0)&&(i==3)) i=0;
 if(select==1) i=3;
 buzzer();
 }
 RE1_bit=0;
 RE0_bit=0;
 if(aux==1) Vint = voltio;
 else Vint = value;

 for(retardo=retardo; retardo<=Vint; retardo++){
 RD0_bit=1;
 mcp4725_ADC(retardo);
 Delay_ms(10);
 }
 for(retardo=retardo; retardo>=Vint; retardo--){
 RD0_bit=1;
 mcp4725_ADC(retardo);
 Delay_ms(10);
 }
}
void adc_readig() {
 unsigned char ch;
 long tlong;

 tlong = (long)adc_rd * 2500;
 tlong = tlong / 1023;
 ch = tlong / 1000;
 Lcd_Chr(2,6,48+ch);
 ch = (tlong / 100) % 10;
 Lcd_Chr_CP(48+ch);
 Lcd_Chr_CP('.');
 ch = (tlong / 10) % 10;
 Lcd_Chr_CP(48+ch);
 ch = tlong % 10;
 Lcd_Chr_CP(48+ch);
}
void main()
{
 Set_up();
 mcp4725_ADC(0);
 delay_ms(200);
 buzzer();
 while (1)
 {
 RD0_bit=0;
 adc_rd = ADC_Read(2);
 delay_ms(1);
 for(wait=0; wait<=100; wait++){
 adc_readig();
 if(Keypad_Key_press()) delay_ms(1), key_pad();
 }
 }
}
